WebSiteASP/Models/Product/ListProductVM.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebSiteASP.Models.Product
{
    using Model.Entity.Product;

    public class ProductVM
    {
        public List<Product> List { get; set; }

        public Product Product { get; set; }

        public List<Category> Categories { get; set; }
    }
}

WebSiteASP/Controllers/DetailController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebSiteASP.Controllers
{
    using Models.Product;
    using Model.Repository.Product;
    using Model.Entity.Product;

    public class DetailController : Controller
    {
        public ActionResult Add()
        {
            CategoryRepository categoryRepository = new CategoryRepository();

            ProductVM productVM = new ProductVM();
            productVM.Product = new Product();
            productVM.Categories = categoryRepository.List();

            return View("Add", productVM);
        }

        [HttpPost]
        public ActionResult Add(Product product)
        {
            ProductRepository productRepository = new ProductRepository();
            CategoryRepository categoryRepository = new CategoryRepository();

            product.Category = categoryRepository.GetCategory(product.CategoryId);
            productRepository.Add(product);

            return RedirectToRoute("HomePage");
        }

        public ActionResult Product(int id)
        {
            ProductRepository productRepository = new ProductRepository();
            CategoryRepository categoryRepository = new CategoryRepository();

            ProductVM productVM = new ProductVM();            
            productVM.Product = productRepository.GetProduct(id);
            productVM.Categories = categoryRepository.List();

            return View("Edit", productVM);
        }

        [HttpPost]
        public ActionResult Product(Product modifiedProduct)
        {
            ProductRepository productRepository = new ProductRepository();
            CategoryRepository categoryRepository = new CategoryRepository();

            Product product = productRepository.GetProduct(modifiedProduct.Id);

            product.Code = modifiedProduct.Code;
            product.Label = modifiedProduct.Label;
            product.Description = modifiedProduct.Description;
            product.Actif = modifiedProduct.Actif;
            product.Category = categoryRepository.GetCategory(modifiedProduct.CategoryId);

            productRepository.Edit(product);

            return RedirectToRoute("HomePage");
        }

        public ActionResult Delete(int id)
        {
            ProductRepository repository = new ProductRepository();
            repository.Delete(id);

            return RedirectToRoute("HomePage");
        }
    }
}

WebSiteASP/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebSiteASP.Controllers
{
    using Models.Product;
    using Model.Repository.Product;
    using Model.Entity.Product;

    public class HomeController : Controller
    {
        public ActionResult Index(String search)
        {
            ProductVM productVM = new ProductVM();

            ProductRepository repository = new ProductRepository();
            productVM.List = repository.Search(search);
                        
            return View(productVM);
        }
        
    }
}

WebSiteASP/Views/Detail/Add.cshtml
@using WebSiteASP.Models.Product
@using Model.Entity.Product
@model ProductVM

@{
    ViewBag.Title = "Add Product Page";
}

<section class="card">
    <article class="card-body">
        <h1>Ajout d'un Produit</h1>

        @using (Html.BeginForm("Add", "Detail"))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">
                <h4>Student</h4>
                <hr />
                @Html.ValidationSummary(true, "Error", new { @class = "text-danger" })

                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Code, new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Code", Model.Product.Code, new { @class = "form-control" })
                    </div>
                </div>
                
                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Label, new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Label", Model.Product.Label, new { @class = "form-control" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Description, new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Description", Model.Product.Description, new { @class = "form-control" })
                    </div>
                </div>

                <div class="form-group d-inline-center">
                    @Html.LabelFor(Model => Model.Product.Actif, new { @class = "control-label d-inline w-auto p-10" })
                    @Html.CheckBox("Actif", Model.Product.Actif, new { @class = "form-control d-inline w-auto p-10" })
                </div>  

                <div class="form-group d-inline-center">
                    @Html.DropDownList("CategoryId", 
                        new SelectList(Model.Categories, "Id", "Label")
                        , "Select Category"
                    )
                </div>

                <div class="form-group d-inline-center">
                    <input type="submit" value="Save" class="btn btn-primary" />
                </div>
            </div>
        }

    </article>
</section>

WebSiteASP/Views/Detail/Edit.cshtml
@using WebSiteASP.Models.Product
@using Model.Entity.Product
@model ProductVM

@{
    ViewBag.Title = "Detail Product Page";
}

<section class="card">
    <article class="card-body">
        <h1>@Model.Product.Label</h1>

        @using (Html.BeginForm("Product", "Detail"))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">
                <h4>Student</h4>
                <hr />
                @Html.ValidationSummary(true, "Error", new { @class = "text-danger" })
                @Html.HiddenFor(Model => Model.Product.Id)

                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Code, new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Code", Model.Product.Code, new { @class = "form-control" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Label, new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Label", Model.Product.Label, new { @class = "form-control" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(Model => Model.Product.Description,new { @class = "control-label" })
                    <div>
                        @Html.TextBox("Description", Model.Product.Description, new { @class = "form-control" })
                    </div>
                </div>

                <div class="form-group d-inline-center">
                    @Html.LabelFor(Model => Model.Product.Actif, new { @class = "control-label d-inline w-auto p-10" })
                    @Html.CheckBox("Actif", Model.Product.Actif, new { @class = "form-control d-inline w-auto p-10" })
                </div>

                <div class="form-group d-inline-center">
                    @Html.DropDownList("CategoryId",
                        new SelectList(Model.Categories, "Id", "Label", Model.Product.Category)
                    )
                </div>

                <div class="form-group d-inline-center">
                    <input type="submit" value="Save" class="btn btn-primary" />
                </div>
            </div>
        }

    </article>
</section>

WebSiteASP/Views/Home/Index.cshtml
@using WebSiteASP.Models.Product
@model ProductVM

@{
    ViewBag.Title = "Home Page";
}

<section class="card">
    <article class="card-body">

        <div class="w-100">
                    
            @using (Html.BeginForm("Index", "Home", FormMethod.Get))
            {
                @Html.TextBox("search", null, new { @class = "d-inline w-80", @placeholder = "Search" })
                        
                <button type="submit" class="btn btn-secondary btn-10 d-inline d-right w-10">
                    <i class="material-icons">search</i>
                </button>
            }

        </div>

        <table class="table table-striped">
            <thead>
                <tr>
                    <th>Code</th>
                    <th>Libelle</th>
                    <th>Prix</th>
                    <th>Stock</th>
                    <th>
                        <a href="@Url.Action("Add", "Detail")" class="btn btn-success btn-10">
                            <i class="material-icons">add</i>
                        </a>
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Model.List.Count() == 0)
                {
                    <tr>
                        <td colspan="5" style="color: darkred">
                            No Entries Match
                        </td>
                    </tr>
                }
                else
                {
                    foreach (var product in Model.List)
                    {
                        <tr>
                            <td>@product.Code</td>
                            <td>@product.Label</td>
                            <td>@product.Price</td>
                            <td>@product.Stock</td>
                            <td>
                                <a href="@Url.Action("Product", "Detail", new { id = product.Id })" class="btn btn-primary btn-10">
                                    <i class="material-icons">edit</i>
                                </a>
                                <a href="@Url.Action("Delete", "Detail", new { id = product.Id })" class="btn btn-danger btn-10">
                                    <i class="material-icons">delete</i>
                                </a>
                            </td>
                        </tr>
                    }
                }

            </tbody>
        </table>

    </article>
</section>

WebSiteASP/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Mon application ASP.NET</title>

    <!-- -------- STYLESHEETS -------- -->

    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
    <!-- Bootstrap core CSS -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet">
    <!-- Material Design Bootstrap -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/mdbootstrap/4.5.4/css/mdb.min.css" rel="stylesheet">

    <!-- Icons -->
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")

</head>
<body>
    <div class="container body-content">
        @RenderBody()

        <hr />
        
        <footer>
            <p>&copy; @DateTime.Now.Year - Caillot - Hebert</p>
        </footer>
    </div>

    <!-- -------- JAVASCRIPTS -------- -->
    
    <!-- JQuery -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <!-- Bootstrap tooltips -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.13.0/umd/popper.min.js"></script>
    <!-- Bootstrap core JavaScript -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0/js/bootstrap.min.js"></script>
    <!-- MDB core JavaScript -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mdbootstrap/4.5.4/js/mdb.min.js"></script>
    
    @RenderSection("scripts", required: false)
</body>
</html>